︠42fd1e0c-34a2-4b88-a6b9-d151fa7e84f7si︠
%md
## From Poirier's Bohmian Mechanics without Wavefunctions, to Hall's Many Interacting Worlds -- in More Than One Dimension ##
︡1bf9448f-f867-453e-80fc-9e59512bdf16︡{"md":"## From Poirier's Bohmian Mechanics without Wavefunctions, to Hall's Many Interacting Worlds -- in More Than One Dimension ##"}︡
︠73a899c3-9f72-471c-9626-7eb21a725001si︠
%md
Ref:

1. [Quantum Mechanics Without Wavefunctions](http://arxiv.org/abs/1201.2382v1)
        Jeremy Schiff and Bill Poirier
        J. Chem. Phys. 136, 031102 (2012)
   <br/>
2. [Quantum Phenomena Modeled by Interactions between Many Classical Worlds](http://arxiv.org/abs/1402.6144)
        Michael J. W. Hall, Dirk-André Deckert and Howard M. Wiseman,
        PHYSICAL REVIEW X 4, 041013 (23 October 2014)
   <br/>
3. [Verlet integration (Wikipedia)](https://en.wikipedia.org/wiki/Verlet_integration#Velocity_Verlet)

   ![](https://upload.wikimedia.org/math/f/9/a/f9ab172405a2d7acf403b98a329e2595.png) <br/>
   ![](https://upload.wikimedia.org/math/5/a/5/5a5a4cebe21a1d0f356c29475971698a.png)
   <br/>
4. [Explicit, Time Reversible, Adaptive Step Size Control](http://archive-ouverte.unige.ch/unige:12120)
        Ernst Hairer and Gustaf Söderlind
        SIAM Journal on Scientific Computing. 2005, vol. 26, no. 6, p. 1838-1851
︡588f0bb4-a3e8-4239-9f8d-58173203d2de︡{"md":"Ref:\n\n1. [Quantum Mechanics Without Wavefunctions](http://arxiv.org/abs/1201.2382v1)\n        Jeremy Schiff and Bill Poirier\n        J. Chem. Phys. 136, 031102 (2012)\n   <br/>\n2. [Quantum Phenomena Modeled by Interactions between Many Classical Worlds](http://arxiv.org/abs/1402.6144)\n        Michael J. W. Hall, Dirk-André Deckert and Howard M. Wiseman,\n        PHYSICAL REVIEW X 4, 041013 (23 October 2014)\n   <br/>\n3. [Verlet integration (Wikipedia)](https://en.wikipedia.org/wiki/Verlet_integration#Velocity_Verlet)\n\n   ![](https://upload.wikimedia.org/math/f/9/a/f9ab172405a2d7acf403b98a329e2595.png) <br/>\n   ![](https://upload.wikimedia.org/math/5/a/5/5a5a4cebe21a1d0f356c29475971698a.png)\n   <br/>\n4. [Explicit, Time Reversible, Adaptive Step Size Control](http://archive-ouverte.unige.ch/unige:12120)\n        Ernst Hairer and Gustaf Söderlind\n        SIAM Journal on Scientific Computing. 2005, vol. 26, no. 6, p. 1838-1851"}︡
︠d2a2d319-dcc1-4c9c-865e-c5939e51eb32s︠
#%typeset_mode True
from numpy import array,concatenate,isnan
from mpmath import erfinv
hbar=var('hbar',latex_name='\\hbar')
mu=var('mu',latex_name='\mu')
︡48bb3550-2203-43c6-aeb1-f36d62ba342d︡
︠2adce2b1-fda2-4d1e-9f17-d8e2da0d13f0si︠
%md
**2-D**

Poirier’s many-D generalization, eq. (18), when specialized to 2-D and discretized by replacing derivatives with difference operators is the 2-D analog of Hall’s “toy” expression eq. (24). Let $x(n,m)$ and $y(n,m)$ represent the position of a particle (one particle in 2-D space) or the position of two particles (in 1-D configuration space) at an unspecified time in the world indexed by $n$ and $m$.
︡e7d65d25-1cbc-4b99-8530-a7a2d10bb443︡{"md":"**2-D**\n\nPoirier’s many-D generalization, eq. (18), when specialized to 2-D and discretized by replacing derivatives with difference operators is the 2-D analog of Hall’s “toy” expression eq. (24). Let $x(n,m)$ and $y(n,m)$ represent the position of a particle (one particle in 2-D space) or the position of two particles (in 1-D configuration space) at an unspecified time in the world indexed by $n$ and $m$."}︡
︠94b2b6de-6d32-461c-ae19-b7879e521ab0s︠
vars = ['x','y']; d = len(vars)
X = map(function,vars); x,y = X
n,m = var('n,m'); ind=[n,m]
# position of particle in world (n,m)
Enm=map(lambda x:x(*ind),X);Enm
︡4abb4f76-d438-4dce-b00a-7702785f6ecf︡{"stdout":"[x(n, m), y(n, m)]\n"}︡
︠50bf24ac-7e38-466b-8a1b-3645a99bb918si︠
%md For Hall's finite number of interacting worlds we will use the following difference operators instead of derivatives.
︡4f2e3c64-d48d-4cd6-a33b-d2d1b0cecbee︡{"md":"For Hall's finite number of interacting worlds we will use the following difference operators instead of derivatives."}︡
︠e345f303-b094-4f85-9f46-1a8a6b495d95s︠
def Dminus(x,i):return(x-x.subs(ind[i]==ind[i]-1))
def Dplus(x,i):return(x.subs(ind[i]==ind[i]+1)-x)
︡3fcb9e75-bccf-48ce-980d-69452459d140︡
︠f977a786-3d15-4ee8-8c3a-85b9ab5bdbd8si︠
%md
The Jacobian replacing derivatives with differences.
︡a3ae855e-95ce-4511-939e-4cfb814f4844︡{"md":"The Jacobian replacing derivatives with differences."}︡
︠592b4c4a-55bb-4e2c-a47f-f70473590155s︠
Jnm = matrix(map(lambda e:[Dminus(e,i) for i in range(d)],Enm));Jnm
︡98bd83ff-55b7-4398-a155-7779f32b55f0︡{"stdout":"[-x(n - 1, m) + x(n, m) -x(n, m - 1) + x(n, m)]\n[-y(n - 1, m) + y(n, m) -y(n, m - 1) + y(n, m)]\n"}︡
︠363703c2-655a-495b-9817-6c349ac947afs︠
# inverse Jacobian
Knm = matrix(map(lambda x: map(lambda y:y.factor(),x),Jnm^(-1)))
︡018525a4-f8fa-469a-a467-61f3d70d314a︡
︠4e8dfd2a-290c-4548-8c30-52c45208952fs︠
# determinant
Dnm=Jnm.determinant(); Dnm
︡93c4bd52-0398-48b7-a323-842c51a2c51e︡{"stdout":"-(x(n, m - 1) - x(n, m))*(y(n - 1, m) - y(n, m)) + (x(n - 1, m) - x(n, m))*(y(n, m - 1) - y(n, m))\n"}︡
︠a4017488-ed3b-48db-a84c-166322a09f31s︠
# minors
Mnm=matrix(map(lambda x: map(lambda y:(y*Dnm).full_simplify(),x),Knm));Mnm
︡270ea157-634a-4abf-a10f-f3b67f63570f︡{"stdout":"[-y(n, m - 1) + y(n, m)  x(n, m - 1) - x(n, m)]\n[ y(n - 1, m) - y(n, m) -x(n - 1, m) + x(n, m)]"}︡{"stdout":"\n"}︡
︠360b69b4-c34a-4808-a046-416a155c0e21s︠
# inverse is minors divided by determinant
def Jdet(n,m): return Dnm.subs({var('n'):n,var('m'):m})
map(lambda x:map(lambda y:y.full_simplify(),x),Mnm/Dnm-Knm)==[[0,0],[0,0]]
︡8b28a685-80f0-41a5-ae5a-1604e897975c︡{"stdout":"True"}︡{"stdout":"\n"}︡
︠e4382214-4b2b-47e2-a228-5bad8ebbba22si︠
%md
### Quantum Force ###

The Schiff and Poirier expression eq. (18) in 2-D has many more terms than in the 1-D case!
︡ee1532f5-2329-4ca5-af63-82b6c976b717︡{"md":"### Quantum Force ###\n\nThe Schiff and Poirier expression eq. (18) in 2-D has many more terms than in the 1-D case!"}︡
︠6e71ab07-819c-4263-b9ca-85e2004c172cs︠
# introduce symbolic determinant
det=function('det')
eq18n = [ (hbar^2/4/mu)*sum([ sum([ sum([ sum([
 Dplus( Mnm[k,i]/det(n,m)*Mnm[p,j]/det(n,m)*Dplus( Dminus( Mnm[l,j]/det(n,m),l ),k ),p )
   for p in range(d)]) for k in range(d)]) for j in range(d)]) for l in range(d)]) for i in range(d)]
# Too large to conveniently display
# eq18n
︡ceaa5677-bef0-4171-9cdb-b971d867f8c1︡
︠ca0bcba3-6057-4a91-931b-5a09f79dc494s︠
# the denominators of both components are the same
show(eq18n[0].denominator())
bool(eq18n[0].denominator()==eq18n[1].denominator())
︡ab76df96-6ba8-4fe3-baee-b629cc88e141︡{"html":"<div align='center'>$\\displaystyle 4 \\, {{\\mu}} {\\rm det}\\left(n + 2, m - 1\\right) {\\rm det}\\left(n + 2, m\\right) {\\rm det}\\left(n + 1, m + 1\\right) {\\rm det}\\left(n + 1, m - 1\\right) {\\rm det}\\left(n + 1, m\\right)^{3} {\\rm det}\\left(n - 1, m + 2\\right) {\\rm det}\\left(n - 1, m + 1\\right) {\\rm det}\\left(n - 1, m\\right) {\\rm det}\\left(n, m + 2\\right) {\\rm det}\\left(n, m + 1\\right)^{3} {\\rm det}\\left(n, m - 1\\right) {\\rm det}\\left(n, m\\right)^{3}$</div>"}︡{"stdout":"True"}︡{"stdout":"\n"}︡
︠4a979106-7701-4f47-bdb6-35f11bfebc64s︠
# expression components are rational functions
eq18numer0=eq18n[0].numerator().subs({det(n+i,m+j):Jdet(n+i,m+j) for i in range(-1,3) for j in range(-1,3)})
eq18denom0=eq18n[0].denominator().subs({det(n+i,m+j):Jdet(n+i,m+j) for i in range(-1,3) for j in range(-1,3)})
eq18numer1=eq18n[1].numerator().subs({det(n+i,m+j):Jdet(n+i,m+j) for i in range(-1,3) for j in range(-1,3)})
eq18denom1=eq18n[1].denominator().subs({det(n+i,m+j):Jdet(n+i,m+j) for i in range(-1,3) for j in range(-1,3)})
︡dcd54fce-1e43-458f-8cab-8bdec698a5b2︡
︠4f359407-8cc3-43f1-a485-d0f951ad62a5s︠
# denominator explicitly
show(eq18denom0)
︡1050f648-7ccc-40a6-8547-47809b924dcd︡{"html":"<div align='center'>$\\displaystyle 4 \\, {\\left({\\left(x\\left(n + 2, m - 1\\right) - x\\left(n + 1, m - 1\\right)\\right)} {\\left(y\\left(n + 2, m - 1\\right) - y\\left(n + 2, m - 2\\right)\\right)} - {\\left(x\\left(n + 2, m - 1\\right) - x\\left(n + 2, m - 2\\right)\\right)} {\\left(y\\left(n + 2, m - 1\\right) - y\\left(n + 1, m - 1\\right)\\right)}\\right)} {\\left({\\left(x\\left(n + 2, m\\right) - x\\left(n + 1, m\\right)\\right)} {\\left(y\\left(n + 2, m - 1\\right) - y\\left(n + 2, m\\right)\\right)} - {\\left(x\\left(n + 2, m - 1\\right) - x\\left(n + 2, m\\right)\\right)} {\\left(y\\left(n + 2, m\\right) - y\\left(n + 1, m\\right)\\right)}\\right)} {\\left({\\left(x\\left(n + 1, m + 1\\right) - x\\left(n, m + 1\\right)\\right)} {\\left(y\\left(n + 1, m + 1\\right) - y\\left(n + 1, m\\right)\\right)} - {\\left(x\\left(n + 1, m + 1\\right) - x\\left(n + 1, m\\right)\\right)} {\\left(y\\left(n + 1, m + 1\\right) - y\\left(n, m + 1\\right)\\right)}\\right)} {\\left({\\left(x\\left(n + 1, m - 1\\right) - x\\left(n, m - 1\\right)\\right)} {\\left(y\\left(n + 1, m - 1\\right) - y\\left(n + 1, m - 2\\right)\\right)} - {\\left(x\\left(n + 1, m - 1\\right) - x\\left(n + 1, m - 2\\right)\\right)} {\\left(y\\left(n + 1, m - 1\\right) - y\\left(n, m - 1\\right)\\right)}\\right)} {\\left({\\left(x\\left(n + 1, m\\right) - x\\left(n, m\\right)\\right)} {\\left(y\\left(n + 1, m - 1\\right) - y\\left(n + 1, m\\right)\\right)} - {\\left(x\\left(n + 1, m - 1\\right) - x\\left(n + 1, m\\right)\\right)} {\\left(y\\left(n + 1, m\\right) - y\\left(n, m\\right)\\right)}\\right)}^{3} {\\left({\\left(x\\left(n - 1, m + 2\\right) - x\\left(n - 2, m + 2\\right)\\right)} {\\left(y\\left(n - 1, m + 2\\right) - y\\left(n - 1, m + 1\\right)\\right)} - {\\left(x\\left(n - 1, m + 2\\right) - x\\left(n - 1, m + 1\\right)\\right)} {\\left(y\\left(n - 1, m + 2\\right) - y\\left(n - 2, m + 2\\right)\\right)}\\right)} {\\left({\\left(x\\left(n, m + 2\\right) - x\\left(n, m + 1\\right)\\right)} {\\left(y\\left(n - 1, m + 2\\right) - y\\left(n, m + 2\\right)\\right)} - {\\left(x\\left(n - 1, m + 2\\right) - x\\left(n, m + 2\\right)\\right)} {\\left(y\\left(n, m + 2\\right) - y\\left(n, m + 1\\right)\\right)}\\right)} {\\left({\\left(x\\left(n - 1, m + 1\\right) - x\\left(n - 2, m + 1\\right)\\right)} {\\left(y\\left(n - 1, m + 1\\right) - y\\left(n - 1, m\\right)\\right)} - {\\left(x\\left(n - 1, m + 1\\right) - x\\left(n - 1, m\\right)\\right)} {\\left(y\\left(n - 1, m + 1\\right) - y\\left(n - 2, m + 1\\right)\\right)}\\right)} {\\left({\\left(x\\left(n, m + 1\\right) - x\\left(n, m\\right)\\right)} {\\left(y\\left(n - 1, m + 1\\right) - y\\left(n, m + 1\\right)\\right)} - {\\left(x\\left(n - 1, m + 1\\right) - x\\left(n, m + 1\\right)\\right)} {\\left(y\\left(n, m + 1\\right) - y\\left(n, m\\right)\\right)}\\right)}^{3} {\\left({\\left(x\\left(n - 1, m\\right) - x\\left(n - 2, m\\right)\\right)} {\\left(y\\left(n - 1, m - 1\\right) - y\\left(n - 1, m\\right)\\right)} - {\\left(x\\left(n - 1, m - 1\\right) - x\\left(n - 1, m\\right)\\right)} {\\left(y\\left(n - 1, m\\right) - y\\left(n - 2, m\\right)\\right)}\\right)} {\\left({\\left(x\\left(n, m - 1\\right) - x\\left(n, m - 2\\right)\\right)} {\\left(y\\left(n - 1, m - 1\\right) - y\\left(n, m - 1\\right)\\right)} - {\\left(x\\left(n - 1, m - 1\\right) - x\\left(n, m - 1\\right)\\right)} {\\left(y\\left(n, m - 1\\right) - y\\left(n, m - 2\\right)\\right)}\\right)} {\\left({\\left(x\\left(n, m - 1\\right) - x\\left(n, m\\right)\\right)} {\\left(y\\left(n - 1, m\\right) - y\\left(n, m\\right)\\right)} - {\\left(x\\left(n - 1, m\\right) - x\\left(n, m\\right)\\right)} {\\left(y\\left(n, m - 1\\right) - y\\left(n, m\\right)\\right)}\\right)}^{3} {{\\mu}}$</div>"}︡
︠5c9964cb-d9bd-4e55-a8dc-e1d48df1c19esi︠
%md Create a numeric function that depends on just the nearest neighbors. This requires a function of 2x5x5 = 50 scalar quantities. 
︡89e3132e-ffb7-4863-be31-e6fd7ded7e7f︡{"md":"Create a numeric function that depends on just the nearest neighbors. This requires a function of 2x5x5 = 50 scalar quantities."}︡
︠993e3611-3d79-43f8-b2a3-7860e7cb474bs︠
xyk=[X[i](n+j,m+k) for j in [-2,-1,0,1,2] for k in [-2,-1,0,1,2] for i in range(d)]
xyv=[var(vars[i]+str(2+j)+str(2+k)) for j in [-2,-1,0,1,2] for k in [-2,-1,0,1,2] for i in range(d)]
show(zip(xyk,xyv))
︡c5d6ff9a-d844-4472-81d1-57c254c1fa8e︡{"html":"<div align='center'>[($\\displaystyle x\\left(n - 2, m - 2\\right)$, $\\displaystyle x_{00}$), ($\\displaystyle y\\left(n - 2, m - 2\\right)$, $\\displaystyle y_{00}$), ($\\displaystyle x\\left(n - 2, m - 1\\right)$, $\\displaystyle x_{01}$), ($\\displaystyle y\\left(n - 2, m - 1\\right)$, $\\displaystyle y_{01}$), ($\\displaystyle x\\left(n - 2, m\\right)$, $\\displaystyle x_{02}$), ($\\displaystyle y\\left(n - 2, m\\right)$, $\\displaystyle y_{02}$), ($\\displaystyle x\\left(n - 2, m + 1\\right)$, $\\displaystyle x_{03}$), ($\\displaystyle y\\left(n - 2, m + 1\\right)$, $\\displaystyle y_{03}$), ($\\displaystyle x\\left(n - 2, m + 2\\right)$, $\\displaystyle x_{04}$), ($\\displaystyle y\\left(n - 2, m + 2\\right)$, $\\displaystyle y_{04}$), ($\\displaystyle x\\left(n - 1, m - 2\\right)$, $\\displaystyle x_{10}$), ($\\displaystyle y\\left(n - 1, m - 2\\right)$, $\\displaystyle y_{10}$), ($\\displaystyle x\\left(n - 1, m - 1\\right)$, $\\displaystyle x_{11}$), ($\\displaystyle y\\left(n - 1, m - 1\\right)$, $\\displaystyle y_{11}$), ($\\displaystyle x\\left(n - 1, m\\right)$, $\\displaystyle x_{12}$), ($\\displaystyle y\\left(n - 1, m\\right)$, $\\displaystyle y_{12}$), ($\\displaystyle x\\left(n - 1, m + 1\\right)$, $\\displaystyle x_{13}$), ($\\displaystyle y\\left(n - 1, m + 1\\right)$, $\\displaystyle y_{13}$), ($\\displaystyle x\\left(n - 1, m + 2\\right)$, $\\displaystyle x_{14}$), ($\\displaystyle y\\left(n - 1, m + 2\\right)$, $\\displaystyle y_{14}$), ($\\displaystyle x\\left(n, m - 2\\right)$, $\\displaystyle x_{20}$), ($\\displaystyle y\\left(n, m - 2\\right)$, $\\displaystyle y_{20}$), ($\\displaystyle x\\left(n, m - 1\\right)$, $\\displaystyle x_{21}$), ($\\displaystyle y\\left(n, m - 1\\right)$, $\\displaystyle y_{21}$), ($\\displaystyle x\\left(n, m\\right)$, $\\displaystyle x_{22}$), ($\\displaystyle y\\left(n, m\\right)$, $\\displaystyle y_{22}$), ($\\displaystyle x\\left(n, m + 1\\right)$, $\\displaystyle x_{23}$), ($\\displaystyle y\\left(n, m + 1\\right)$, $\\displaystyle y_{23}$), ($\\displaystyle x\\left(n, m + 2\\right)$, $\\displaystyle x_{24}$), ($\\displaystyle y\\left(n, m + 2\\right)$, $\\displaystyle y_{24}$), ($\\displaystyle x\\left(n + 1, m - 2\\right)$, $\\displaystyle x_{30}$), ($\\displaystyle y\\left(n + 1, m - 2\\right)$, $\\displaystyle y_{30}$), ($\\displaystyle x\\left(n + 1, m - 1\\right)$, $\\displaystyle x_{31}$), ($\\displaystyle y\\left(n + 1, m - 1\\right)$, $\\displaystyle y_{31}$), ($\\displaystyle x\\left(n + 1, m\\right)$, $\\displaystyle x_{32}$), ($\\displaystyle y\\left(n + 1, m\\right)$, $\\displaystyle y_{32}$), ($\\displaystyle x\\left(n + 1, m + 1\\right)$, $\\displaystyle x_{33}$), ($\\displaystyle y\\left(n + 1, m + 1\\right)$, $\\displaystyle y_{33}$), ($\\displaystyle x\\left(n + 1, m + 2\\right)$, $\\displaystyle x_{34}$), ($\\displaystyle y\\left(n + 1, m + 2\\right)$, $\\displaystyle y_{34}$), ($\\displaystyle x\\left(n + 2, m - 2\\right)$, $\\displaystyle x_{40}$), ($\\displaystyle y\\left(n + 2, m - 2\\right)$, $\\displaystyle y_{40}$), ($\\displaystyle x\\left(n + 2, m - 1\\right)$, $\\displaystyle x_{41}$), ($\\displaystyle y\\left(n + 2, m - 1\\right)$, $\\displaystyle y_{41}$), ($\\displaystyle x\\left(n + 2, m\\right)$, $\\displaystyle x_{42}$), ($\\displaystyle y\\left(n + 2, m\\right)$, $\\displaystyle y_{42}$), ($\\displaystyle x\\left(n + 2, m + 1\\right)$, $\\displaystyle x_{43}$), ($\\displaystyle y\\left(n + 2, m + 1\\right)$, $\\displaystyle y_{43}$), ($\\displaystyle x\\left(n + 2, m + 2\\right)$, $\\displaystyle x_{44}$), ($\\displaystyle y\\left(n + 2, m + 2\\right)$, $\\displaystyle y_{44}$)]</div>"}︡
︠ffa45c16-5a02-4363-b448-68ef210aecc7s︠
# suitable values
constants = {hbar:0.2,mu:1.0}
# compile numeric functions
ff0=fast_callable(eq18numer0.subs(dict(zip(xyk,xyv))).subs(constants), vars=xyv, domain=RDF)
ff1=fast_callable(eq18numer1.subs(dict(zip(xyk,xyv))).subs(constants), vars=xyv, domain=RDF)
ffd=fast_callable(eq18denom0.subs(dict(zip(xyk,xyv))).subs(constants), vars=xyv, domain=RDF)
def ff(p): den=ffd(*p); return array([ff0(*p)/den,ff1(*p)/den])
︡54024678-f189-4837-bccf-7d710d98ecf9︡
︠1694bf35-a792-4493-a1df-d2a9d918d067si︠
%md
### Quantum Potential###
***Why does Poirier eq. (20) include a second term?***  If we include it then total energy $T+V+Q$ is not conserved!
︡2692171e-e242-4603-bb13-414d098c757b︡{"md":"### Quantum Potential###\n***Why does Poirier eq. (20) include a second term?***  If we include it then total energy $T+V+Q$ is not conserved!"}︡
︠a6990bdb-8135-4274-ab59-07e5b963087cs︠
eq20nm = sum([ sum([ sum([
 (hbar^2/4/mu)*(Knm[k,j]*Dplus( Dplus( Knm[l,j],l ),k )+1/2*Dplus(Knm[l,j],l)*Dplus(Knm[k,j],k))
   for k in range(d)]) for j in range(d)]) for l in range(d)])
#too complex to display conveniently
#eq20nm
︡b4d09678-d23e-4d5b-abcc-82dd1ce1300e︡
︠1daf31b3-b9b7-4b70-addc-3453ccb66df1si︠
%md
Expand terms using symbolic determinants.
︡edddd46c-dd24-41f4-aed3-4c951a76e691︡{"md":"Expand terms using symbolic determinants."}︡
︠c15580e9-56e7-4467-ae27-36af7f6d759fs︠
eq20nm1 = sum([ sum([ sum([
 (hbar^2/4/mu)*(Mnm[k,j]/det(n,m)*Dplus( Dplus( Mnm[l,j]/det(n,m),l ),k ))
   for k in range(d)]) for j in range(d)]) for l in range(d)])
show(eq20nm1.subs({hbar:1,mu:1}).expand().combine().collect(det(n,m)).collect(det(n+2,m)).collect(det(n+1,m+1)).collect(det(n+1,m)).collect(det(n,m+1)) )
︡8ae5cdfb-5183-4192-b6f8-0fa5cc664ed6︡{"html":"<div align='center'>$\\displaystyle \\frac{x\\left(n - 1, m\\right)^{2} - 2 \\, x\\left(n - 1, m\\right) x\\left(n, m - 1\\right) + x\\left(n, m - 1\\right)^{2} + y\\left(n - 1, m\\right)^{2} - 2 \\, y\\left(n - 1, m\\right) y\\left(n, m - 1\\right) + y\\left(n, m - 1\\right)^{2}}{4 \\, {\\rm det}\\left(n, m\\right)^{2}} + \\frac{x\\left(n + 2, m - 1\\right) x\\left(n, m - 1\\right) - x\\left(n + 2, m\\right) x\\left(n, m - 1\\right) - x\\left(n + 2, m - 1\\right) x\\left(n, m\\right) + x\\left(n + 2, m\\right) x\\left(n, m\\right) + y\\left(n + 2, m - 1\\right) y\\left(n, m - 1\\right) - y\\left(n + 2, m\\right) y\\left(n, m - 1\\right) - y\\left(n + 2, m - 1\\right) y\\left(n, m\\right) + y\\left(n + 2, m\\right) y\\left(n, m\\right)}{4 \\, {\\rm det}\\left(n + 2, m\\right) {\\rm det}\\left(n, m\\right)} + \\frac{x\\left(n + 1, m + 1\\right) x\\left(n - 1, m\\right) - x\\left(n + 1, m\\right) x\\left(n - 1, m\\right) + x\\left(n + 1, m + 1\\right) x\\left(n, m - 1\\right) - x\\left(n, m + 1\\right) x\\left(n, m - 1\\right) - 2 \\, x\\left(n + 1, m + 1\\right) x\\left(n, m\\right) + x\\left(n + 1, m\\right) x\\left(n, m\\right) + x\\left(n, m + 1\\right) x\\left(n, m\\right) + y\\left(n + 1, m + 1\\right) y\\left(n - 1, m\\right) - y\\left(n + 1, m\\right) y\\left(n - 1, m\\right) + y\\left(n + 1, m + 1\\right) y\\left(n, m - 1\\right) - y\\left(n, m + 1\\right) y\\left(n, m - 1\\right) - 2 \\, y\\left(n + 1, m + 1\\right) y\\left(n, m\\right) + y\\left(n + 1, m\\right) y\\left(n, m\\right) + y\\left(n, m + 1\\right) y\\left(n, m\\right)}{4 \\, {\\rm det}\\left(n + 1, m + 1\\right) {\\rm det}\\left(n, m\\right)} + \\frac{x\\left(n + 1, m - 1\\right) x\\left(n - 1, m\\right) - x\\left(n + 1, m\\right) x\\left(n - 1, m\\right) - 2 \\, x\\left(n + 1, m - 1\\right) x\\left(n, m - 1\\right) + x\\left(n + 1, m\\right) x\\left(n, m - 1\\right) + x\\left(n + 1, m - 1\\right) x\\left(n, m\\right) + x\\left(n, m - 1\\right) x\\left(n, m\\right) - x\\left(n, m\\right)^{2} + y\\left(n + 1, m - 1\\right) y\\left(n - 1, m\\right) - y\\left(n + 1, m\\right) y\\left(n - 1, m\\right) - 2 \\, y\\left(n + 1, m - 1\\right) y\\left(n, m - 1\\right) + y\\left(n + 1, m\\right) y\\left(n, m - 1\\right) + y\\left(n + 1, m - 1\\right) y\\left(n, m\\right) + y\\left(n, m - 1\\right) y\\left(n, m\\right) - y\\left(n, m\\right)^{2}}{4 \\, {\\rm det}\\left(n + 1, m\\right) {\\rm det}\\left(n, m\\right)} + \\frac{x\\left(n - 1, m + 2\\right) x\\left(n - 1, m\\right) - x\\left(n - 1, m\\right) x\\left(n, m + 2\\right) - x\\left(n - 1, m + 2\\right) x\\left(n, m\\right) + x\\left(n, m + 2\\right) x\\left(n, m\\right) + y\\left(n - 1, m + 2\\right) y\\left(n - 1, m\\right) - y\\left(n - 1, m\\right) y\\left(n, m + 2\\right) - y\\left(n - 1, m + 2\\right) y\\left(n, m\\right) + y\\left(n, m + 2\\right) y\\left(n, m\\right)}{4 \\, {\\rm det}\\left(n, m + 2\\right) {\\rm det}\\left(n, m\\right)} - \\frac{2 \\, x\\left(n - 1, m + 1\\right) x\\left(n - 1, m\\right) - x\\left(n - 1, m\\right) x\\left(n, m + 1\\right) - x\\left(n - 1, m + 1\\right) x\\left(n, m - 1\\right) + x\\left(n, m + 1\\right) x\\left(n, m - 1\\right) - x\\left(n - 1, m + 1\\right) x\\left(n, m\\right) - x\\left(n - 1, m\\right) x\\left(n, m\\right) + x\\left(n, m\\right)^{2} + 2 \\, y\\left(n - 1, m + 1\\right) y\\left(n - 1, m\\right) - y\\left(n - 1, m\\right) y\\left(n, m + 1\\right) - y\\left(n - 1, m + 1\\right) y\\left(n, m - 1\\right) + y\\left(n, m + 1\\right) y\\left(n, m - 1\\right) - y\\left(n - 1, m + 1\\right) y\\left(n, m\\right) - y\\left(n - 1, m\\right) y\\left(n, m\\right) + y\\left(n, m\\right)^{2}}{4 \\, {\\rm det}\\left(n, m + 1\\right) {\\rm det}\\left(n, m\\right)}$</div>"}︡
︠442f6a08-394b-44e2-9ce6-98e4fb2b97b5s︠
eq20nm2 = sum([ sum([ sum([
 (hbar^2/4/mu)*(1/2*Dplus(Mnm[l,j]/det(n,m),l)*Dplus(Mnm[k,j]/det(n,m),k))
   for k in range(d)]) for j in range(d)]) for l in range(d)])
︡632b6d72-6ddc-4bfe-9d74-bc8e3e96b0d6︡
︠fd0b8b65-0901-4011-9b77-1dbc4c951b8es︠
show(eq20nm2.subs({hbar:1,mu:1}))
︡c5716758-12a1-4f2d-a29f-e905ba26d9b0︡{"html":"<div align='center'>$\\displaystyle \\frac{1}{8} \\, {\\left(\\frac{x\\left(n + 1, m - 1\\right) - x\\left(n + 1, m\\right)}{{\\rm det}\\left(n + 1, m\\right)} - \\frac{x\\left(n, m - 1\\right) - x\\left(n, m\\right)}{{\\rm det}\\left(n, m\\right)}\\right)}^{2} + \\frac{1}{8} \\, {\\left(\\frac{y\\left(n + 1, m - 1\\right) - y\\left(n + 1, m\\right)}{{\\rm det}\\left(n + 1, m\\right)} - \\frac{y\\left(n, m - 1\\right) - y\\left(n, m\\right)}{{\\rm det}\\left(n, m\\right)}\\right)}^{2} - \\frac{1}{4} \\, {\\left(\\frac{x\\left(n + 1, m - 1\\right) - x\\left(n + 1, m\\right)}{{\\rm det}\\left(n + 1, m\\right)} - \\frac{x\\left(n, m - 1\\right) - x\\left(n, m\\right)}{{\\rm det}\\left(n, m\\right)}\\right)} {\\left(\\frac{x\\left(n - 1, m + 1\\right) - x\\left(n, m + 1\\right)}{{\\rm det}\\left(n, m + 1\\right)} - \\frac{x\\left(n - 1, m\\right) - x\\left(n, m\\right)}{{\\rm det}\\left(n, m\\right)}\\right)} + \\frac{1}{8} \\, {\\left(\\frac{x\\left(n - 1, m + 1\\right) - x\\left(n, m + 1\\right)}{{\\rm det}\\left(n, m + 1\\right)} - \\frac{x\\left(n - 1, m\\right) - x\\left(n, m\\right)}{{\\rm det}\\left(n, m\\right)}\\right)}^{2} - \\frac{1}{4} \\, {\\left(\\frac{y\\left(n + 1, m - 1\\right) - y\\left(n + 1, m\\right)}{{\\rm det}\\left(n + 1, m\\right)} - \\frac{y\\left(n, m - 1\\right) - y\\left(n, m\\right)}{{\\rm det}\\left(n, m\\right)}\\right)} {\\left(\\frac{y\\left(n - 1, m + 1\\right) - y\\left(n, m + 1\\right)}{{\\rm det}\\left(n, m + 1\\right)} - \\frac{y\\left(n - 1, m\\right) - y\\left(n, m\\right)}{{\\rm det}\\left(n, m\\right)}\\right)} + \\frac{1}{8} \\, {\\left(\\frac{y\\left(n - 1, m + 1\\right) - y\\left(n, m + 1\\right)}{{\\rm det}\\left(n, m + 1\\right)} - \\frac{y\\left(n - 1, m\\right) - y\\left(n, m\\right)}{{\\rm det}\\left(n, m\\right)}\\right)}^{2}$</div>"}︡
︠d1405d51-120a-42b0-9437-1bc931f432c1si︠
%md
Manually reorganizing terms, we can put it into another form.
︡505bebef-09b9-4223-b653-bef3cf3335bb︡{"md":"Manually reorganizing terms, we can put it into another form."}︡
︠97e2d324-6797-4e42-b1cb-d67aee37d4d9s︠
eq20nm4=((x(n+1,m-1)-x(n+1,m))^2+(y(n+1,m-1)-y(n+1,m))^2)/8/det(n+1,m)^2 + ((x(n-1,m+1)-x(n,m+1))^2+(y(n-1,m+1)-y(n,m+1))^2)/8/det(n,m+1)^2 + ((x(n-1,m)-x(n,m-1))^2+(y(n-1,m)-y(n,m-1))^2)/8/det(n,m)^2 - ((x(n-1,m+1)-x(n,m+1))*(x(n-1,m)-x(n,m-1)) + (y(n-1,m+1)-y(n,m+1))*(y(n-1,m)-y(n,m-1)))/4/det(n,m+1)/det(n,m) + ((x(n+1,m-1)-x(n+1,m))*(x(n-1,m)-x(n,m-1)) + (y(n+1,m-1)-y(n+1,m))*(y(n-1,m)-y(n,m-1)))/4/det(n+1,m)/det(n,m) - ((x(n+1,m-1)-x(n+1,m))*(x(n-1,m+1)-x(n,m+1)) + (y(n+1,m-1)-y(n+1,m))*(y(n-1,m+1)-y(n,m+1)))/4/det(n+1,m)/det(n,m+1)
show(eq20nm4)
︡0aeed254-6778-45be-88e0-7b0205e28bea︡{"html":"<div align='center'>$\\displaystyle \\frac{{\\left(x\\left(n + 1, m - 1\\right) - x\\left(n + 1, m\\right)\\right)}^{2} + {\\left(y\\left(n + 1, m - 1\\right) - y\\left(n + 1, m\\right)\\right)}^{2}}{8 \\, {\\rm det}\\left(n + 1, m\\right)^{2}} + \\frac{{\\left(x\\left(n - 1, m + 1\\right) - x\\left(n, m + 1\\right)\\right)}^{2} + {\\left(y\\left(n - 1, m + 1\\right) - y\\left(n, m + 1\\right)\\right)}^{2}}{8 \\, {\\rm det}\\left(n, m + 1\\right)^{2}} - \\frac{{\\left(x\\left(n + 1, m - 1\\right) - x\\left(n + 1, m\\right)\\right)} {\\left(x\\left(n - 1, m + 1\\right) - x\\left(n, m + 1\\right)\\right)} + {\\left(y\\left(n + 1, m - 1\\right) - y\\left(n + 1, m\\right)\\right)} {\\left(y\\left(n - 1, m + 1\\right) - y\\left(n, m + 1\\right)\\right)}}{4 \\, {\\rm det}\\left(n + 1, m\\right) {\\rm det}\\left(n, m + 1\\right)} + \\frac{{\\left(x\\left(n - 1, m\\right) - x\\left(n, m - 1\\right)\\right)}^{2} + {\\left(y\\left(n - 1, m\\right) - y\\left(n, m - 1\\right)\\right)}^{2}}{8 \\, {\\rm det}\\left(n, m\\right)^{2}} + \\frac{{\\left(x\\left(n + 1, m - 1\\right) - x\\left(n + 1, m\\right)\\right)} {\\left(x\\left(n - 1, m\\right) - x\\left(n, m - 1\\right)\\right)} + {\\left(y\\left(n + 1, m - 1\\right) - y\\left(n + 1, m\\right)\\right)} {\\left(y\\left(n - 1, m\\right) - y\\left(n, m - 1\\right)\\right)}}{4 \\, {\\rm det}\\left(n + 1, m\\right) {\\rm det}\\left(n, m\\right)} - \\frac{{\\left(x\\left(n - 1, m + 1\\right) - x\\left(n, m + 1\\right)\\right)} {\\left(x\\left(n - 1, m\\right) - x\\left(n, m - 1\\right)\\right)} + {\\left(y\\left(n - 1, m + 1\\right) - y\\left(n, m + 1\\right)\\right)} {\\left(y\\left(n - 1, m\\right) - y\\left(n, m - 1\\right)\\right)}}{4 \\, {\\rm det}\\left(n, m + 1\\right) {\\rm det}\\left(n, m\\right)}$</div>"}︡
︠6c3b6132-d6cc-492f-b4c6-d05f2dcd9c5ds︠
bool((eq20nm2.subs({hbar:1,mu:1})-eq20nm4).full_simplify()==0)

︡c98fb184-8ded-402b-802c-8fb9590b60ae︡{"stdout":"True"}︡{"stdout":"\n"}︡
︠1fbb269b-aa86-4801-8e81-7e1223e4cf76si︠
%md
But for the computation we don't really need the determinants. (Only use the second term.)
︡fcdfc5cd-5512-4dbd-bcf0-18faaec18a93︡{"md":"But for the computation we don't really need the determinants. (Only use the second term.)"}︡
︠74e2b60a-6e45-4901-80fa-382bd8ca2c6as︠
eq20nm0 = sum([ sum([ sum([
 (hbar^2/4/mu)*(1/2*Dplus(Knm[l,j],l)*Dplus(Knm[k,j],k))
   for k in range(d)]) for j in range(d)]) for l in range(d)])
show(eq20nm0.collect(hbar).collect(mu))
︡091e343e-3fdc-4383-bbd5-905ae478ba4a︡{"html":"<div align='center'>$\\displaystyle \\frac{{\\left({\\left(\\frac{x\\left(n + 1, m - 1\\right) - x\\left(n + 1, m\\right)}{x\\left(n + 1, m\\right) y\\left(n + 1, m - 1\\right) - x\\left(n, m\\right) y\\left(n + 1, m - 1\\right) - x\\left(n + 1, m - 1\\right) y\\left(n + 1, m\\right) + x\\left(n, m\\right) y\\left(n + 1, m\\right) + x\\left(n + 1, m - 1\\right) y\\left(n, m\\right) - x\\left(n + 1, m\\right) y\\left(n, m\\right)} - \\frac{x\\left(n, m - 1\\right) - x\\left(n, m\\right)}{x\\left(n, m - 1\\right) y\\left(n - 1, m\\right) - x\\left(n, m\\right) y\\left(n - 1, m\\right) - x\\left(n - 1, m\\right) y\\left(n, m - 1\\right) + x\\left(n, m\\right) y\\left(n, m - 1\\right) + x\\left(n - 1, m\\right) y\\left(n, m\\right) - x\\left(n, m - 1\\right) y\\left(n, m\\right)}\\right)}^{2} + 2 \\, {\\left(\\frac{x\\left(n + 1, m - 1\\right) - x\\left(n + 1, m\\right)}{x\\left(n + 1, m\\right) y\\left(n + 1, m - 1\\right) - x\\left(n, m\\right) y\\left(n + 1, m - 1\\right) - x\\left(n + 1, m - 1\\right) y\\left(n + 1, m\\right) + x\\left(n, m\\right) y\\left(n + 1, m\\right) + x\\left(n + 1, m - 1\\right) y\\left(n, m\\right) - x\\left(n + 1, m\\right) y\\left(n, m\\right)} - \\frac{x\\left(n, m - 1\\right) - x\\left(n, m\\right)}{x\\left(n, m - 1\\right) y\\left(n - 1, m\\right) - x\\left(n, m\\right) y\\left(n - 1, m\\right) - x\\left(n - 1, m\\right) y\\left(n, m - 1\\right) + x\\left(n, m\\right) y\\left(n, m - 1\\right) + x\\left(n - 1, m\\right) y\\left(n, m\\right) - x\\left(n, m - 1\\right) y\\left(n, m\\right)}\\right)} {\\left(\\frac{x\\left(n - 1, m + 1\\right) - x\\left(n, m + 1\\right)}{x\\left(n, m + 1\\right) y\\left(n - 1, m + 1\\right) - x\\left(n, m\\right) y\\left(n - 1, m + 1\\right) - x\\left(n - 1, m + 1\\right) y\\left(n, m + 1\\right) + x\\left(n, m\\right) y\\left(n, m + 1\\right) + x\\left(n - 1, m + 1\\right) y\\left(n, m\\right) - x\\left(n, m + 1\\right) y\\left(n, m\\right)} + \\frac{x\\left(n - 1, m\\right) - x\\left(n, m\\right)}{x\\left(n, m - 1\\right) y\\left(n - 1, m\\right) - x\\left(n, m\\right) y\\left(n - 1, m\\right) - x\\left(n - 1, m\\right) y\\left(n, m - 1\\right) + x\\left(n, m\\right) y\\left(n, m - 1\\right) + x\\left(n - 1, m\\right) y\\left(n, m\\right) - x\\left(n, m - 1\\right) y\\left(n, m\\right)}\\right)} + {\\left(\\frac{x\\left(n - 1, m + 1\\right) - x\\left(n, m + 1\\right)}{x\\left(n, m + 1\\right) y\\left(n - 1, m + 1\\right) - x\\left(n, m\\right) y\\left(n - 1, m + 1\\right) - x\\left(n - 1, m + 1\\right) y\\left(n, m + 1\\right) + x\\left(n, m\\right) y\\left(n, m + 1\\right) + x\\left(n - 1, m + 1\\right) y\\left(n, m\\right) - x\\left(n, m + 1\\right) y\\left(n, m\\right)} + \\frac{x\\left(n - 1, m\\right) - x\\left(n, m\\right)}{x\\left(n, m - 1\\right) y\\left(n - 1, m\\right) - x\\left(n, m\\right) y\\left(n - 1, m\\right) - x\\left(n - 1, m\\right) y\\left(n, m - 1\\right) + x\\left(n, m\\right) y\\left(n, m - 1\\right) + x\\left(n - 1, m\\right) y\\left(n, m\\right) - x\\left(n, m - 1\\right) y\\left(n, m\\right)}\\right)}^{2} + {\\left(\\frac{y\\left(n + 1, m - 1\\right) - y\\left(n + 1, m\\right)}{x\\left(n + 1, m\\right) y\\left(n + 1, m - 1\\right) - x\\left(n, m\\right) y\\left(n + 1, m - 1\\right) - x\\left(n + 1, m - 1\\right) y\\left(n + 1, m\\right) + x\\left(n, m\\right) y\\left(n + 1, m\\right) + x\\left(n + 1, m - 1\\right) y\\left(n, m\\right) - x\\left(n + 1, m\\right) y\\left(n, m\\right)} - \\frac{y\\left(n, m - 1\\right) - y\\left(n, m\\right)}{x\\left(n, m - 1\\right) y\\left(n - 1, m\\right) - x\\left(n, m\\right) y\\left(n - 1, m\\right) - x\\left(n - 1, m\\right) y\\left(n, m - 1\\right) + x\\left(n, m\\right) y\\left(n, m - 1\\right) + x\\left(n - 1, m\\right) y\\left(n, m\\right) - x\\left(n, m - 1\\right) y\\left(n, m\\right)}\\right)}^{2} + 2 \\, {\\left(\\frac{y\\left(n + 1, m - 1\\right) - y\\left(n + 1, m\\right)}{x\\left(n + 1, m\\right) y\\left(n + 1, m - 1\\right) - x\\left(n, m\\right) y\\left(n + 1, m - 1\\right) - x\\left(n + 1, m - 1\\right) y\\left(n + 1, m\\right) + x\\left(n, m\\right) y\\left(n + 1, m\\right) + x\\left(n + 1, m - 1\\right) y\\left(n, m\\right) - x\\left(n + 1, m\\right) y\\left(n, m\\right)} - \\frac{y\\left(n, m - 1\\right) - y\\left(n, m\\right)}{x\\left(n, m - 1\\right) y\\left(n - 1, m\\right) - x\\left(n, m\\right) y\\left(n - 1, m\\right) - x\\left(n - 1, m\\right) y\\left(n, m - 1\\right) + x\\left(n, m\\right) y\\left(n, m - 1\\right) + x\\left(n - 1, m\\right) y\\left(n, m\\right) - x\\left(n, m - 1\\right) y\\left(n, m\\right)}\\right)} {\\left(\\frac{y\\left(n - 1, m + 1\\right) - y\\left(n, m + 1\\right)}{x\\left(n, m + 1\\right) y\\left(n - 1, m + 1\\right) - x\\left(n, m\\right) y\\left(n - 1, m + 1\\right) - x\\left(n - 1, m + 1\\right) y\\left(n, m + 1\\right) + x\\left(n, m\\right) y\\left(n, m + 1\\right) + x\\left(n - 1, m + 1\\right) y\\left(n, m\\right) - x\\left(n, m + 1\\right) y\\left(n, m\\right)} + \\frac{y\\left(n - 1, m\\right) - y\\left(n, m\\right)}{x\\left(n, m - 1\\right) y\\left(n - 1, m\\right) - x\\left(n, m\\right) y\\left(n - 1, m\\right) - x\\left(n - 1, m\\right) y\\left(n, m - 1\\right) + x\\left(n, m\\right) y\\left(n, m - 1\\right) + x\\left(n - 1, m\\right) y\\left(n, m\\right) - x\\left(n, m - 1\\right) y\\left(n, m\\right)}\\right)} + {\\left(\\frac{y\\left(n - 1, m + 1\\right) - y\\left(n, m + 1\\right)}{x\\left(n, m + 1\\right) y\\left(n - 1, m + 1\\right) - x\\left(n, m\\right) y\\left(n - 1, m + 1\\right) - x\\left(n - 1, m + 1\\right) y\\left(n, m + 1\\right) + x\\left(n, m\\right) y\\left(n, m + 1\\right) + x\\left(n - 1, m + 1\\right) y\\left(n, m\\right) - x\\left(n, m + 1\\right) y\\left(n, m\\right)} + \\frac{y\\left(n - 1, m\\right) - y\\left(n, m\\right)}{x\\left(n, m - 1\\right) y\\left(n - 1, m\\right) - x\\left(n, m\\right) y\\left(n - 1, m\\right) - x\\left(n - 1, m\\right) y\\left(n, m - 1\\right) + x\\left(n, m\\right) y\\left(n, m - 1\\right) + x\\left(n - 1, m\\right) y\\left(n, m\\right) - x\\left(n, m - 1\\right) y\\left(n, m\\right)}\\right)}^{2}\\right)} {{\\hbar}}^{2}}{8 \\, {{\\mu}}}$</div>"}︡
︠f5e1396b-4b24-45e9-a859-6f64bc32b4d4si︠
%md
Numeric form.
︡ffb7b46d-94a5-40b8-b3ac-c06fe680fb17︡{"md":"Numeric form."}︡
︠685edc81-efdd-49bd-b4cd-6a1fc4cb98a1s︠
eq20nm3=eq20nm0.subs(dict(zip(xyk,xyv)))
ru=fast_callable(eq20nm3.subs({hbar:0.2,mu:1.0}), vars=xyv, domain=RDF)
︡a37484bf-bbc7-4873-b06d-11a779300dbf︡
︠ff30db46-de6c-4d13-b6fa-26f1ba40f781si︠
%md
### Classical force ###
︡6aae82ca-2b92-4a26-a4e7-1e86156054c0︡{"md":"### Classical force ###"}︡
︠c328f35f-bd3b-4f77-9430-1d4b17463a93s︠
F0(x)= 9*sech(5*x)^2*tanh(5*x)
︡f64b2854-573f-4484-b7cb-539f92ccf3c6︡
︠e256b87b-90f2-4d1b-bd72-4cbf7a3e9152s︠
plot(F0,(-3,3),axes_labels=['distance','force'],axes_labels_size=1)
︡70f21fa2-5092-4879-b5c3-84e00161006c︡{"once":false,"file":{"show":true,"uuid":"6e7c33b1-f95e-43eb-9f78-0de19a87e4a9","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/3297/tmp_cyuIJp.svg"}}︡{"html":"<div align='center'></div>"}︡
︠20be7f40-9278-4a63-8495-16fd8d739382si︠
%md
### Classical potential ###
︡7ec27bd8-f6b2-499d-aba9-c35be6eab6a0︡{"md":"### Classical potential ###"}︡
︠0d5ce662-1e8e-441d-9c2b-1d9daf5086c2s︠
P0(x)=9/(10*cosh(5*x)^2)
︡e229b97c-8eaf-4e39-af75-4c09ce53b0bd︡
︠eb10dcfe-8769-477b-a2ac-1825b17badc8s︠
plot(P0,(-3,3),axes_labels=['distance','energy'],axes_labels_size=1,legend_label='potential')
︡78728b9d-375d-435b-a024-9505947959a8︡{"once":false,"file":{"show":true,"uuid":"8de68321-f6c3-4063-b70d-f96b0edbbdf4","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/3297/tmp_4UXuVM.svg"}}︡{"html":"<div align='center'></div>"}︡
︠93c92db3-4456-4951-9420-9f0e5efc928dsi︠
%md Numeric form.
︡f0085ec5-a905-4956-9006-5ca7b0acc565︡{"md":"Numeric form."}︡
︠c1deef95-4bca-474d-b9e7-debb2302cbd1s︠
F1=fast_callable(F0(x11), vars=[x11], domain=RDF)
def FF(xy): FF1=F1(xy[0]-xy[1]); return array([FF1,-FF1])
def PO(xy): return P0(xy[0]-xy[1])
︡d7e5c450-ae92-4a51-a308-d9511b4fd52b︡
︠9ebc20c1-71d4-44a8-abfc-1765df13bc65si︠
%md
### Initial Conditions ###

Consider two particles in a one dimensional space over 4 worlds.  The initial configuration space is shown below.
︡21aeeccc-ad4f-4058-b212-e3eed3a1e062︡{"md":"### Initial Conditions ###\n\nConsider two particles in a one dimensional space over 4 worlds.  The initial configuration space is shown below."}︡
︠564ae1d0-a428-4ff6-bbff-8143c0bffb1cs︠
N=2; M=2
r0=array([[[(i-0.5)/N,(j-0.5)/M] for j in range(-M/2+1,M/2+1)] for i in range(-N/2+1,N/2+1)])
p0=array(map(lambda y:map(lambda x:array([1.0*RDF(erfinv(2.0*x[0])-2.0+x[1]/2),RDF(erfinv(2.0*x[1])+2.0+x[0]/2)]),y),r0))
list_plot([r0[i,j] for i in range(N) for j in range(M)])+list_plot([p0[i,j] for i in range(N) for j in range(M)],color='red',figsize=[5,5])
︡a5bd0dc0-2f89-48a1-a00a-4d3a2ea11f12︡{"once":false,"file":{"show":true,"uuid":"9fe4d339-19ad-492d-8a08-2142a0287069","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/3297/tmp_DBO8Aw.svg"}}︡{"html":"<div align='center'></div>"}︡
︠71b4602b-c40b-4aaf-8b03-6e1a12f3b1e8si︠
%md
The particles approach each other with the same initial velocity in each world.
︡b062c46d-4d51-47ce-aa12-c19abc40e17e︡{"md":"The particles approach each other with the same initial velocity in each world."}︡
︠49e1c2f5-659d-47c6-b8c8-31d922483855s︠
v0=array([[[RDF(1.0),RDF(-1.0)] for j in range(M)] for i in range(N)])
︡c66b7fa5-12cd-4177-8e3f-faff448501b4︡
︠b9a0bf26-7dd4-4be0-9637-803de7345552si︠
%md
In order to compute the quantum force on the particles in world $n,m$ we introduce ficticious worlds at "approximate infinity" to represent open boundry conditions.
︡eb52ca34-53de-4019-af79-da1ce599c939︡{"md":"In order to compute the quantum force on the particles in world $n,m$ we introduce ficticious worlds at \"approximate infinity\" to represent open boundry conditions."}︡
︠73dc51ac-9152-4a6f-8cbe-3b0ac032bf69s︠
inf = RDF(10.0^12);
inf2 = RDF(10.0^6);
def rf1(XY,n,m):
    global N,M
    p=[[XY[n+i,m+j][0],XY[n+i,m+j][1]] if n+i>=0 and m+j>=0 and n+i<N and m+j<M else [
      -inf if n+i<-1 else -inf2 if n+i<=-1 else inf if n+i>N else inf2 if n+i>=N else XY[n+i,m][0],
      -inf if m+j<-1 else -inf2 if m+j<=-1 else inf if m+j>M else inf2 if m+j>=M else XY[n,m+j][1]]
        for i in [-2,-1,0,1,2] for j in [-2,-1,0,1,2]]
    p=reduce(lambda x,y:x+y,p)
    r=ff(p)
    if isnan(r[0]): print "r[0] isnan"
    if isnan(r[1]): print "r[1] isnan"
    return r
︡42ce2b2a-0645-458d-867a-fe597f53cb9c︡
︠cb879b39-f1f5-47ce-bc7e-7ece53e63548si︠
%md
### Total classical potential ###
︡b40d2044-5d2f-454b-ac1a-c62bef4a8e3d︡{"md":"### Total classical potential ###"}︡
︠ccdcaf2f-d5da-44ba-8e2e-8b6943ef443es︠
def PU(x): return sum([PO(x[i,j]) for i in range(N) for j in range(M)])
︡101c7408-2049-4487-bf36-9cb05a43e294︡
︠173d9f85-2451-447b-9e20-433cadd73e78si︠
%md
### Total quantum Potential ###
︡a04657c2-0d31-4f3a-954e-7bfff5024f2f︡{"md":"### Total quantum Potential ###"}︡
︠7e17e1f7-40be-4a9e-94fc-930c3c025667s︠
def ru1(XY,n,m):
    global N,M
    nm=n+m+1
    p=[[XY[n+i,m+j][0],XY[n+i,m+j][1]] if n+i>=0 and m+j>=0 and n+i<N and m+j<M else [
      -inf if n+i<-1 else -inf2 if n+i<=-1 else inf if n+i>N else inf2 if n+i>=N else XY[n+i,m][0],
      -inf if m+j<-1 else -inf2 if m+j<=-1 else inf if m+j>M else inf2 if m+j>=M else XY[n,m+j][1]]
        for i in [-2,-1,0,1,2] for j in [-2,-1,0,1,2]]
    p=reduce(lambda x,y:x+y,p)
    return ru(*p)
def QU(x): return sum([ru1(x,i,j) for i in range(N) for j in range(M)])
︡3a1b5ecb-16fa-42fc-94ed-5308a558dd63︡
︠40fdd742-7574-4263-9dee-330ea20815c3si︠
%md
### Total kinetic energy ###
︡4076a439-b931-4ac4-812b-3343fa010298︡{"md":"### Total kinetic energy ###"}︡
︠f1e0d9de-97e8-4dad-9269-682015d134c3s︠
def K(x): return RDF(0.5)*sum([sum(x[i,j]^2) for i in range(N) for j in range(M)])
︡8d7d5624-eaff-454c-9bb8-75c0a85b7372︡
︠94358db9-e7bc-4b70-bfa0-20dbeb54e0easi︠
%md
### Simulation ###
Run the integration using Störmer–Verlet discretization with a continuous integrating stepsize controller.
︡8172c2bc-35cd-4d4b-b6ec-0ef026bd2abe︡{"md":"### Simulation ###\nRun the integration using Störmer–Verlet discretization with a continuous integrating stepsize controller."}︡
︠36dcfdb6-22e7-420f-b002-c542eae175das︠
%time
t_end = 6.0; step = .04
# initial step size
ds = RDF(0.001)
# controller
alpha = RDF(30.0); beta = RDF(0.0)
# step density
rho = RDF(1.0); dt=ds/rho
def G(p,q):
    a = sum([sum(p[i,j]*q[i,j]) for j in range(M) for i in range(N)])
    b = sum([sum(q[i,j]*q[i,j]) for j in range(M) for i in range(N)])
    eps = RDF(10.0^-10)
    return -alpha*a/max(b,eps)+beta*(1.0-ds/dt)
#acceleration = (quantum force + classical force)/mass
mm = RDF(1.0)
def A(x): return RDF(0.5)*array([[(rf1(x,i,j)+FF(XY[i,j]))/mm for j in range(M)] for i in range(N)])
# initial values
XY = p0.copy(); VV = v0.copy(); AX = A(XY)
rho = rho - RDF(0.5)*G(AX,VV)*dt
t = 0;  tt = [t]
XV = [ [ [ [XY[i,j][0],XY[i,j][1]] for i in range(N)] for j in range(M)] ]
KK=K(VV); PP=PU(XY); QQ=QU(XY)
T1=KK+PP+QQ
rhos = [rho]; TK={t:KK}; TP={t:PP};TQ={t:QQ}; T=[T1]
while t<t_end:
    t1 = t+step
    while t<t1:
        rho = rho + G(AX,VV)*dt
        if isnan(rho) or rho>100 or rho<0.01:
            print "Step control failed at %s. rho=%s"%(t,rho)
            t=t_end; break
        dt = ds/rho; t += dt
        # note 0.5 in A above
        XY += VV*dt + AX*dt^2
        VV += AX*dt; AX = A(XY); VV += AX*dt
    # Check total energy conservation
    KK=K(VV); PP=PU(XY); QQ=QU(XY)
    T2=KK+PP+QQ
    if abs(T1-T2)>0.1:
        print "Integration failed at %s. Try a shorter time step: %s."%(t,ds/2)
        #break
    T1=T2
    # record
    XV = XV + [ [ [ [XY[i,j][0],XY[i,j][1]] for i in range(N)] for j in range(M)] ]; tt += [t]
    rhos.append(rho); TK[t]=KK; TP[t]=PP; TQ[t]=QQ; T.append(T1)
︡50bbcfd2-fd80-446b-b5c9-e812ea50bd3f︡{"stdout":"CPU time: 33.48 s, Wall time: 41.55 s"}︡{"stdout":"\n"}︡
︠320f5bef-0769-4c7c-91af-19abb94aa2a6s︠
line2d(zip(tt,rhos),axes_labels=['time','rho'],legend_label='step density')
(line2d([[t,TK[t]] for t in tt],axes_labels=['time','energy'],legend_label='kinetic',color='green')+
 line2d([[t,TQ[t]] for t in tt],axes_labels=['time','energy'],legend_label='quantum potential',color='red')+
 line2d([[t,TP[t]] for t in tt],axes_labels=['time','energy'],legend_label='classical potential',color='blue'))
line2d(zip(tt,T),axes_labels=['time','energy'],legend_label='total',color='black')
︡e155a8a9-17da-4641-8a30-6bb38391deea︡{"once":false,"file":{"show":true,"uuid":"78260082-1af0-4e3a-9808-c71f6c0ad637","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/3297/tmp_a_KbyR.svg"}}︡{"html":"<div align='center'></div>"}︡{"once":false,"file":{"show":true,"uuid":"07707093-05d8-4518-8328-9615ee7bad32","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/3297/tmp_yxv7v0.svg"}}︡{"html":"<div align='center'></div>"}︡{"once":false,"file":{"show":true,"uuid":"e8f45824-a5d4-4700-a555-1844edcf31d3","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/3297/tmp_7yylNR.svg"}}︡{"html":"<div align='center'></div>"}︡
︠bd7d1093-c594-47de-bcac-70014e999123s︠
line2d([[t,TQ[t]] for t in tt],axes_labels=['time','energy'],legend_label='quantum potential',color='red')
︡634ac93d-2121-4164-adcd-3ae22303be06︡{"once":false,"file":{"show":true,"uuid":"93cc60ba-c3de-462d-8cd2-40d3c9aa5af3","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/3297/tmp_x_qZ9S.svg"}}︡{"html":"<div align='center'></div>"}︡
︠07b6c619-533f-49e9-8087-d8bc233480ddsi︠
%md
You might want something like this: https://addons.mozilla.org/En-US/firefox/addon/toggle-animated-gifs/ to manage the animation.

*Start/stop GIF animations through a keyboard shortcut or by clicking them. You can also restart animations from the beginning, or disable animations by default.*
%md
Each point in the following diagram represents the position of two particles. When the point approaches the x=y line

︡56178bcd-7a25-45a9-87c5-f74b6e2924b7︡{"md":"You might want something like this: https://addons.mozilla.org/En-US/firefox/addon/toggle-animated-gifs/ to manage the animation.\n\n*Start/stop GIF animations through a keyboard shortcut or by clicking them. You can also restart animations from the beginning, or disable animations by default.*\n%md\nEach point in the following diagram represents the position of two particles. When the point approaches the x=y line"}︡
︠9bc44812-7a13-47bc-b020-197511ea98e3si︠
%md
Each moving point in the following diagram represents the position of two particles in a single world (four worlds are shown). As the point approaches the x=y line (shown in <span style="color:red">red</span>), the particles approach each other and the classical potential is at a maximum. In three worlds the particles overcome the potential barrier and continue. But one world (the last to approach) is reflected back. Although initially the two particles in each world approach each other with the same velocity, the particles in the last world to approach the barrier have lost energy to their counterparts in other worlds due to the quantum mechanical (interworld) interaction. When viewed in the projection we see two particles rebound instead of passing each other.
︡e85f596d-4089-4347-8a03-140c0bf5809e︡{"md":"Each moving point in the following diagram represents the position of two particles in a single world (four worlds are shown). As the point approaches the x=y line (shown in <span style=\"color:red\">red</span>), the particles approach each other and the classical potential is at a maximum. In three worlds the particles overcome the potential barrier and continue. But one world (the last to approach) is reflected back. Although initially the two particles in each world approach each other with the same velocity, the particles in the last world to approach the barrier have lost energy to their counterparts in other worlds due to the quantum mechanical (interworld) interaction. When viewed in the projection we see two particles rebound instead of passing each other."}︡
︠3b4a672d-d82e-4092-8de4-f3efdced6d49s︠
animate([text("time:"+("%4.1f"%x[0]).rjust(6), (6,3),color='black') +
text("kinetic:"+("%.4e"%TK[x[0]]).rjust(10), (6,2.5),color='black') +
text("classic:"+("%.4e"%TP[x[0]]).rjust(10), (6,2),color='black') +
text("quantum:"+("%.4e"%TQ[x[0]]).rjust(10), (6,1.5),color='black') +
line([[-6,-6],[6,6]],color='red',legend_label='potential barrier') +
  list_plot([x[1][i][j] for j in range(N) for i in range(M)],xmin=-6,xmax=6,ymin=-6,ymax=6) for x in zip(tt,XV)]).show(gif=true,delay=20)
︡0b4223eb-1905-4f7f-a554-7d552a2cab81︡{"once":false,"file":{"show":true,"uuid":"2c0b2582-d111-42d9-8846-81a301267198","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/3297/tmp_1915en.gif"}}︡{"html":"<div align='center'></div>"}︡
︠ca5ec930-57ed-4ea9-bff0-6d2afa82ef3as︠
show(sum([line([[tt[i],XV[i][j][k][0]] for i in range(0,len(tt))],color = 'red') for j in range(M) for k in range(N)])+
     sum([line([[tt[i],XV[i][j][k][1]] for i in range(0,len(tt))],color = 'blue') for j in range(M) for k in range(N)])
  ,figsize=[10,7],axes_labels=['time','location'],axes_labels_size=1)
︡5723d3f0-0448-43dd-be94-1401ac826f14︡{"once":false,"file":{"show":true,"uuid":"98e64a69-2b25-4034-9c1f-00c962698bde","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/3297/tmp_zJ7Iau.svg"}}︡{"html":"<div align='center'></div>"}︡
︠ae9fa23c-b659-420b-98c7-4cfc2564f48es︠
animate([text("time:"+("%4.1f"%x[0]).rjust(5), (3,3),color='black') +
  list_plot([[x[1][i][j][0],PO(x[1][i][j])] for j in range(N) for i in range(M)],xmin=-6,xmax=6,ymin=0,ymax=3,color='red')+
  list_plot([[x[1][i][j][1],PO(x[1][i][j])] for j in range(N) for i in range(M)],xmin=-6,xmax=6,ymin=0,ymax=3,color='blue') for x in zip(tt,XV)]).show(gif=true,delay=20)
︡9c99f905-4ac7-4c25-870c-4da08aac913a︡{"once":false,"file":{"show":true,"uuid":"1726054a-6200-462f-8c6d-cc2bed635bf8","filename":"/projects/b04b5777-e269-4c8f-a4b8-b21dbe1c93c6/.sage/temp/compute4-us/3297/tmp_BA3vII.gif"}}︡{"html":"<div align='center'></div>"}︡
︠1f4df735-c5c9-4e94-a757-5824b859a526︠









